<%--
  Copyright 2003 Sun Microsystems, Inc. All rights reserved 
  Use is subject to license terms.
 --%>
<%-- @(#)portal.jsp --%>
<%@ page import="java.util.*" %>

<%@ taglib uri="/tld/desktop.tld" prefix="dt" %>
<%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc" %>
<%@ taglib uri="/tld/desktopTheme.tld" prefix="dttheme" %>
<%@ taglib uri="/tld/i18n.tld" prefix="i18n" %>

<dt:obtainChannel channel="$JSPProvider">
    <dt:getName id="channelName" scope="request"/>
    <dtpc:providerContext>
        <i18n:setBundle baseName="DiscussionsJSP" var="discussionsjsp" />
	<!-- set the desktop theme variables -->
	<dttheme:getAttribute name="bgColor" id="tBgColor" scope="request"/>
	<dttheme:getAttribute name="titleBarColor" id="tTitleBarColor" scope="request"/>
	<dttheme:getAttribute name="titleFontColor" id="tTitleFontColor" default="#000000" scope="request"/>
	<dttheme:getAttribute name="tabColor" id="tTabColor" default="#C0C0C0" scope="request"/>
	<dttheme:getAttribute name="tabFontColor" id="tTabFontColor" default="#000000" scope="request"/>
	<dttheme:getAttribute name="channelHighlightColor" id="channelHighlightColor" default="#FFFFFF" scope="request"/>
	<dttheme:getAttribute name="fontColor" id="tFontColor" scope="request"/>
	<dttheme:getAttribute name="borderColor" id="tBorderColor" scope="request"/>
	<dttheme:getAttribute name="fontFace" id="tFontFace" scope="request"/>
	<dttheme:getAttribute name="borderWidth" id="tBorderWidth" scope="request"/>

	<%-- search channel properties --%>
	<dtpc:getIntegerProperty key="viewHits" id="hitNumber" scope="request"/>
	<dtpc:getBooleanProperty key="viewDiscussionWindow" id="vdw" scope="request"/> 
	<dtpc:getStringProperty key="defaultDiscussionDisplay" id="ddd" scope="request"/>
	<dtpc:getStringProperty key="defaultFilter" id="df" scope="request"/>
	<dtpc:getStringProperty key="defaultExpansionThreshold" id="det" scope="request"/>
	<dtpc:getStringProperty key="anonymousAuthor" id="anonymousAuthor" scope="request"/>
	<dtpc:getStringProperty key="dbname" id="dbname" scope="request"/>
	<% try { %>
	<dtpc:getStringProperty key="searchChannel" id="searchChannel" scope="request"/>
	<% } catch (Exception e) { 
            // setting to "Search" for backward compatibility
            pageContext.setAttribute("searchChannel","Search");
        }%>
        <% try { %>
            <dtpc:getStringProperty key="subscriptionChannel" id="subscriptionChannel" scope="request"/>
        <%  pageContext.setAttribute("containerName","",PageContext.REQUEST_SCOPE);
        } catch (Exception e) {
            pageContext.setAttribute("subscriptionChannel", "Subscriptions",PageContext.REQUEST_SCOPE);
            pageContext.setAttribute("containerName","CollaborationTabPanelContainer",PageContext.REQUEST_SCOPE);
        } %>

	<dtpc:getBooleanProperty key="displaySearch" id="displaySearch" scope="request"/>
	<dtpc:getBooleanProperty key="showDescription" id="showDesc" scope="request"/>
	<dtpc:getStringAttribute key="commonname" id="gn" scope="request"/>
	<dtpc:getStringAttribute key="sn" id="lastname" scope="request"/>
	<dtpc:getSessionID id="accessToken" scope="request"/>
	<dtpc:getUserID id="authorId" scope="request"/>
	<dtpc:getLocale id="locale" scope="request"/>
	<dtpc:getDesktopURL id="desktopUrl" scope="request"/>

	<%
        String discussionChannel = (String) pageContext.findAttribute("channelName");
        if (discussionChannel == null || discussionChannel.trim().length() == 0) {
            discussionChannel = "Discussions";  // setting to "Discussions" for backward compatibility
            pageContext.setAttribute("channelName",discussionChannel);
        }
        String searchChannel = (String) pageContext.findAttribute("searchChannel");
        Map pathInfo = new HashMap();
        pathInfo.put("action", "content");
        pathInfo.put("provider", "JSPDynamicSingleContainer");
        pathInfo.put("JSPDynamicSingleContainer.selectedChannel", searchChannel);
        pathInfo.put("last", "false");
        pageContext.setAttribute("pathInfo", pathInfo);
	%>
	<dtpc:getDesktopURL id="searchInSingleContainerURL" pathinfo="$pathInfo" scope="request"/>

	<%
        pathInfo.put("JSPDynamicSingleContainer.selectedChannel", discussionChannel);
        pageContext.setAttribute("pathInfo2", pathInfo);
	%>
	<dtpc:getDesktopURL id="discussionInSingleContainerURL" pathinfo="$pathInfo2" scope="request"/>
	<% 
	Map desktopArgsMap = new HashMap(); 
	Enumeration params = request.getParameterNames(); 
	while (  params.hasMoreElements() ) { 
	    String paramKey = (String)params.nextElement(); 
	    String paramValue = request.getParameter(paramKey); 
	    // Do not add internal parameters to the path info.
	    if ((!paramKey.equalsIgnoreCase(discussionChannel+"_dmode")) &&
		(!paramKey.equalsIgnoreCase("did")) &&
		(!paramKey.equalsIgnoreCase("ddatabase")) &&
		(!paramKey.equalsIgnoreCase("ref_id")) &&
		(!paramKey.equalsIgnoreCase("t")) &&
		(!paramKey.equalsIgnoreCase("title")) &&
		(!paramKey.equalsIgnoreCase("desc")) &&
		(!paramKey.equalsIgnoreCase("htmldesc")) &&
		(!paramKey.equalsIgnoreCase("rtg")) &&
		(!paramKey.equalsIgnoreCase("rid")) &&
		(!paramKey.equalsIgnoreCase("provider")) &&
		(!paramKey.equalsIgnoreCase("targetprovider")) &&
		(!paramKey.equalsIgnoreCase("action")) &&
		(!paramKey.equalsIgnoreCase("page"))) {
                    desktopArgsMap.put(paramKey, paramValue); 
	    }
	} 
	desktopArgsMap.put("action","content");
	pageContext.setAttribute("desktopArgs", desktopArgsMap); 
	%> 
	<dtpc:getDesktopURL id="dpurl" pathinfo="$desktopArgs" scope="request"/>

	<dtpc:getStringProperty key="searchServer" id="searchServer" scope="request"/>
   </dtpc:providerContext>
</dt:obtainChannel>
