<%@ page import="
com.sun.portal.providers.containers.jsp.single.JSPSingleContainerProvider,
com.sun.portal.providers.containers.jsp.table.JSPTableContainerProvider,
com.sun.portal.providers.containers.jsp.tab.UnmodifiableTab,
com.sun.portal.providers.containers.jsp.tab.JSPTabContainerProvider,
com.sun.portal.providers.containers.jsp.menu.JSPMenuContainerProvider,
com.sun.portal.providers.Provider,
com.sun.portal.providers.util.PropertyUtil,
java.util.Map,
java.util.List"
%>

<%!
public void setTableContainerChannels(String container, JSPTableContainerProvider tcp, HttpServletRequest request) throws Exception {  
    List availableChannels = tcp.getAvailableChannels();
    List selectedChannels = tcp.getSelectedChannels();
    Map channelsRemovable = null;
    boolean defaultIsRemovable = false;
    channelsRemovable = tcp.getProviderContext().getCollectionProperty(tcp.getName(), "channelsIsRemovable");
    defaultIsRemovable = tcp.getProviderContext().getBooleanProperty(tcp.getName(), "defaultChannelIsRemovable");
    for (int i = 0; i < availableChannels.size(); i++) {
        String channel = (String)availableChannels.get(i);
        if (!PropertyUtil.getBooleanValueFromMap(channelsRemovable, channel, defaultIsRemovable)) {
            continue;
        }
        String checkBoxValue = request.getParameter(channel);
        if (checkBoxValue == null) {
            selectedChannels.remove(channel);
        } else if (checkBoxValue.equals( "1" )) {
            if (!selectedChannels.contains(channel)) {
                selectedChannels.add(channel);
            }
        }
    }
    tcp.setSelectedChannels(selectedChannels);
}
%>

<%!
public void setMenuContainerChannels(String container, JSPMenuContainerProvider mcp, HttpServletRequest request) throws Exception {  

    List availableChannels = mcp.getAvailableChannels();
    List selectedChannels = mcp.getSelectedChannels();

    String startTabName = mcp.getStartTabName();
    String selectedTabName = mcp.getSelectedTabName();
    boolean startTabRemoved = false;
    boolean selectedTabRemoved = false;

    int size = availableChannels.size();
    for (int i = 0; i < size; i++) {
        String channel = (String)availableChannels.get(i);
        String checkBoxValue = request.getParameter(channel);
        if (checkBoxValue == null) {
            selectedChannels.remove(channel);

            // If we're removing the start tab, we need to set the start tab to a new value.
            if (channel.equals(startTabName)) {
              startTabRemoved=true;
            }

            // check if we're removing the selected tab
            if (channel.equals(selectedTabName)) {
              selectedTabRemoved=true;
            }
        } else if (checkBoxValue.equals( "1" )) {
            if (!selectedChannels.contains(channel)) {
                selectedChannels.add(channel);
            }
        }
    }

    size = selectedChannels.size();
    if (size > 0) {

      mcp.setSelectedChannels(selectedChannels);
      String firstRemaining = (String)selectedChannels.get(0);

      // If we're removing the start tab, we'll set the start tab to first tab in the list
      if (startTabRemoved) {
          mcp.setStartTabName(firstRemaining);
      }

      // If we're removing the selected tab, we need set the selected tab to first tab in the list
      if (selectedTabRemoved) {
        mcp.setSelectedTabName(firstRemaining);
      }
    }
}
%>

<%
 /*
  * These are constants shared by content and process jsps and
  * refer to the state of the processing (saving) of page prefs
  */
String COMPLETE = "complete";
String INCOMPLETE = "incomplete";
String ERROR = "error";

String container = (String)request.getParameter("container");
JSPSingleContainerProvider scp = (JSPSingleContainerProvider)pageContext.getAttribute("JSPProvider");
String parentContainerProvider = scp.getProviderContext().getProviderName(container);

JSPTableContainerProvider tcp = null;
JSPMenuContainerProvider mcp = null; 

if (parentContainerProvider.equals("JSPTableContainerProvider")) {
    tcp = (JSPTableContainerProvider)scp.getContainerProviderContext().getProvider(request, scp.getName(), container); 
    if (tcp != null) {
      setTableContainerChannels(container, tcp, request);
    }
} else if (parentContainerProvider.equals("JSPMenuContainerProvider")) {
    mcp = (JSPMenuContainerProvider)scp.getContainerProviderContext().getProvider(request, scp.getName(), container);
    if (mcp != null) {
      setMenuContainerChannels(container, mcp, request);
    }
}
session.setAttribute("pagePrefsState", COMPLETE);
%>
