/**
 * Prompt user when logout button is pressed.
 *
 * @param message - localize message with confirmation text
 */
function confirmLogout(message) {
    c = confirm(message);
    if (c != null && c == true) {
        closeWindows();
    }
    return c;
}

/**
 * Prompt user for channel removal.
 *
 * @param channel - name of channel to remove
 * @param name - name of new window
 */
function confirmRemoveChannel(channel, newLocation) {
    c = confirm("Are you sure you want to remove " + channel + "?");
    if (c) {
        location.href = newLocation;
        return true;
    }
    return false;
}

/**
 * Open new browser window and set focus to it.
 *
 * @param href - href of page for new window
 * @param name - name of new window
 */
function openWindow(href, name) {
    name = window.open(href, name, 'scrollbars,resizable,width=650,height=500,top='+((screen.height - (screen.height/1.618))-(500/2))+',left='+((screen.width-650)/2));
    name.focus();
}

/**
 * close window .
 *
 * @param name - name of window
 */
function closeWindow(name) {
    name.close();
}

/**
 *  Make current page occupy entire browser window.
 */
function occupyFullBrowser() {
    if (top.location != window.location) {
        top.location = window.location;
    }
}

/**
 * Place cursor on the first form element.
 */
function placeCursorOnFirstElm() {
    var frms = document.forms;
    var frmCount = frms.length;

    for (var i = 0; i < frmCount; i++) {
	var frm = frms[i];
	var sz = frm.elements.length;

	for (var j = 0; j < sz; j++) {
	    var elm = frm.elements[j];

	    if (elm.type != "hidden") {
		elm.focus();
		return;
	    }
	}
    }
}

/**
 * Clears all form elements.
 *
 * @param frm - form obj
 */
function clearFormElms(frm) {
    if (frm != null) {
	var elms = frm.elements;

	if ((elms != null) && (elms.length > 0)) {
	    for (var i = 0; i < elms.length; i++) {
		var elm = elms[i];
		elm.value = "";
	    }
	}
    }
}

function openChannelMenu(form,id,menu) {
  form.ccmenuid.value = id;
  window.showMenu(menu);
}

function closeChannelMenu(form,action) {
  form.ccmenuaction.value = action;
  form.submit();
}

function channelClick(form,id,action) {
  form.ccmenuid.value = id;
  form.ccmenuaction.value = action;
  form.submit();
}

function channelKeyPress(e,form,id,action) {
  var keycode = (window.event)
    ? window.event.keyCode
    : e.which;
  if (keycode == 13) {
    channelClick(form,id,action);
    return false;
  }
  return true;
}
