<%--
  Copyright 2003 Sun Microsystems, Inc. All rights reserved
  Use is subject to license terms.
 --%>

<%@ page import="com.sun.portal.wireless.taglibs.mail.MailContext"%>
<%@ page import="com.sun.ssoadapter.SSOAdapter"%>
<%@ page import="com.iplanet.sso.SSOToken"%>
<%@ page import="java.util.Map"%>
<%@ page import="java.util.HashMap"%>

<%@ page errorPage="error.jsp"%>

<%@ taglib uri="/tld/jx.tld" prefix="jx" %>
<%@ taglib uri="/tld/desktop.tld" prefix="dt" %>
<%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc" %>
<%@ taglib uri="/tld/ssoadapter.tld" prefix="sso" %>
<%@ taglib uri="/tld/urlBuilder.tld" prefix="buildurl" %>
<%@ taglib uri="/tld/wireless_ab.tld" prefix="ab" %>

<dt:obtainChannel channel="$JSPProvider">
<dtpc:providerContext>
<%
	Map errorMap = new HashMap();
%>
<!-- SSOAdapter properties -->
<dtpc:getStringProperty key="ssoAdapter" id="ssoName"/>
<sso:adapter configname="$ssoName">
    <sso:getproperty key="enableProxyAuth" id="enableProxyAuth"/>
</sso:adapter><%
    //Normalize the string value, to take care of case differences e.g. false, FALSE, False
    String isEnableProxyAuth = (String)pageContext.getAttribute("enableProxyAuth");
    //Check for null and blank values of enableProxyAuth
    if ((isEnableProxyAuth == null) || (isEnableProxyAuth.trim().length() == 0)) {
        isEnableProxyAuth = "false";
    } else {
        isEnableProxyAuth = isEnableProxyAuth.toLowerCase();
    }
    pageContext.setAttribute("isEnableProxyAuth", isEnableProxyAuth);
%><jx:if test='$isEnableProxyAuth == "false"'>
<dt:getName id="channelName"/>
<sso:adapter configname="$ssoName" id="newSSOAdapter" channelname="$channelName">
        <dtpc:getLocalePropertiesFilters id="localeFilter"/>
	<dtpc:getCollectionProperty key="ssoEditAttributes" id="ssoEditAttributes" pfList="$localeFilter"/>
<%	%><jx:forEach var="item" items="$ssoEditAttributes"><%
			%><sso:editmapdata data="prop" id="prop" mapid="item"/><%
			%><sso:editmapdata data="type" id="type" mapid="item"/><%
	// Need to check request parameters for matching properties
			String value = request.getParameter((String)pageContext.getAttribute("prop"));
			pageContext.setAttribute("value",value);
			%>
            <jx:if test="$type != 'password'">
                <sso:setproperty key="$prop" value="$value"/>
            </jx:if>
            <jx:if test="$type == 'password'">
                <jx:if test="$value != '********'">
                    <sso:setproperty key="$prop" value="$value"/>
                </jx:if>
            </jx:if>
	 </jx:forEach>
</sso:adapter>
<%-- New SSOAdapter has been created if user modified entries --%>
<sso:adapter key="newSSOAdapter">
	<sso:getname id="newSSOName"/>
<%
	// Workaround until jx problem gets solved
	String newSSOName = (String) pageContext.getAttribute("newSSOName");
	if (newSSOName != null) {
		String ssoName = (String) pageContext.getAttribute("ssoName");
		if (! newSSOName.equals(ssoName)) { 
			%><dtpc:setStringProperty key="ssoAdapter" value="$newSSOName"/><%
		} else {
            try{
			// This will init the url builder session every time a process is done.
			%><buildurl:session forceinit="true"/><%
            }catch(Exception ex) {
               //ex.printStackTrace();
            }
            try {
			// This will init the ab context every time a process is done.
			%><ab:context config="${newSSOName}" reset="true" test="true"/><%
            }catch(Exception ex){
            }
		}
	}
%></sso:adapter>
</jx:if><%



		
// Display properties 
%><dtpc:getIntegerProperty id="maxEntries" key="maxEntries"/><%
%><jx:declare id="maxEntries" type="Integer"/><%
	int numEntries=10;
	try {
		numEntries = Integer.parseInt(request.getParameter("numEntries"));
		if ((numEntries < 0) || (numEntries > maxEntries.intValue())){
			errorMap.put("headerError","outOfRange");
			errorMap.put("headerValue",request.getParameter("numEntries"));
		} else {
			pageContext.setAttribute("numEntries",new Integer(numEntries));
		%><dtpc:setIntegerProperty key="numberEntries" value="$numEntries"/><%
		}
	} catch (NumberFormatException nfee){
		// Error spouting here
		errorMap.put("headerError","NaN");
		errorMap.put("headerValue",request.getParameter("numEntries"));
	}

%><dt:getName id="jsChannelName"/><%
%><jx:declare id="jsChannelName" type="java.lang.String"/><%
	jsChannelName = jsChannelName.replace('/','_');
	// Set the session state in the pageContext as attribute jsChannelName:
	Map state = (Map) pageContext.getAttribute(jsChannelName,PageContext.SESSION_SCOPE);
	if (state == null){
		state = new HashMap(5);
	}

	// Sort order - allowed values:	cnd cna emd ema
	// Preference sortDir can be "down" "up"
	String sort = request.getParameter("sort");
	if (sort != null){
		if (sort.endsWith("d")){
			%><dtpc:setStringProperty key="sortOrder" value="down"/><%
            state.put("absortdir", "dsc");
		} else if (sort.endsWith("a")){
			%><dtpc:setStringProperty key="sortOrder" value="up"/><%
            state.put("absortdir", "up");
		}
	}
 
	// Initial View
	String abview = request.getParameter("abview");
	if (abview != null){
		pageContext.setAttribute("abview",abview);
		%><dtpc:setStringProperty key="initialView" value="$abview"/><%
        state.put("abview", abview);
        state.put("abstart", new Integer(1));
	}

    pageContext.setAttribute(jsChannelName, state, PageContext.SESSION_SCOPE);

        // Maybe dispatch to MA Mail JSP
	if (request.getParameter("MobileAddressBook") != null) {
		Map redirectMap = new HashMap();
	        redirectMap.put("targetprovider", "MAAddressBookJSP");
                redirectMap.put("action", "edit");
                redirectMap.put("provider", request.getParameter("provider"));
                redirectMap.put("containerName", request.getParameter("containerName"));
                pageContext.setAttribute("redirectMap",redirectMap);
%><dtpc:getDesktopURL id="url" querymap="$redirectMap"/><%
%><jx:declare id="url" type="String"/><%
	        response.sendRedirect(url);

	} 

	if (errorMap.size() > 0){
		errorMap.put("action", "edit");
		// Encoding needed?
		errorMap.put("provider", request.getParameter("provider"));
		if (errorMap.get("targetprovider") == null)
                    errorMap.put("targetprovider", request.getParameter("targetprovider"));
		errorMap.put("containerName", request.getParameter("containerName"));
		pageContext.setAttribute("errorMap",errorMap);

%><dtpc:getDesktopURL id="url" querymap="$errorMap"/><%
	} else {
%><dtpc:getDesktopURL id="url"/><%
	}
%><jx:declare id="url" type="String"/><%
	response.sendRedirect(url);
%>
</dtpc:providerContext>
</dt:obtainChannel>

