<%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc"
%><%@ taglib uri="/tld/desktopContainerProviderContext.tld" prefix="dtcpc"
%><%@ taglib uri="/tld/desktop.tld" prefix="dt"
%><%@ taglib uri="/tld/jx.tld" prefix="jx"
%><%@ page import="java.util.*"%>

<%
 /* These are constants shared by content and process jsps and
  * refer to the state of the processing (saving) of account prefs
  */
String COMPLETE = "complete";
String INCOMPLETE = "incomplete";
String ERROR = "error";

// The keys and long titles for pages
Hashtable titles = new Hashtable();
titles.put("password", "Password");
titles.put("contactinfo", "Contact Information");
titles.put("timezone", "Time Zone"); 

String startPage = "password";

/* The current page can be one of the following:
 * 1. the start page
 * 2. the user clicked on another page to make it the current page
 * 3. the user is returing from saving changes via the process form and so the 
 *    current page is in the session and so it's state must be "reset".
 */
String accountPrefsPage = startPage;
if ((String)request.getParameter("accountPrefsPage") != null) {
  accountPrefsPage = (String)request.getParameter("accountPrefsPage");
} else if ((String)session.getAttribute("accountPrefsPage") != null &&
           !((String)session.getAttribute("accountPrefsPage")).equals(INCOMPLETE)) {
  accountPrefsPage = (String)session.getAttribute("accountPrefsPage");
  session.setAttribute("accountPrefsPage", INCOMPLETE);
}
String accountPrefsPageContent = accountPrefsPage + "/" + "content.jsp";
String accountPrefsFormValidation = accountPrefsPage + "/" + "contentFormValidation.jsp";
%>

<%! 
/* 
 * Get the CSS class value for the html li according to if the titleKey in titles
 * matches the current accountPrefsPage (Selected) or not (Unselected).
 */
public String getCSSClassValue(String titleKey, String accountPrefsPage) {
  String classValue = "Unselected";
  if (titleKey.equals(accountPrefsPage)) {
    classValue = "Selected";
  }
  return classValue;
} %>


<dt:obtainContainer container="$JSPProvider">
  <jsp:include page="header.jsp" flush="true"/>

  <div class="shortContainer">
    <!-- Begin Secondary Tab Navigation --> 
    <table cellpadding="0" cellspacing="0" border="0" width="100%">
  
    <tr>
    <td nowrap width="40%">
      <div id="secondaryContainerNavigation">
        <span class="selectedDivider">|</span>
	<li><a href="<dtpc:getDesktopURL/>?provider=AccountPreferencesContainer&accountPrefsPage=password&last=false" class="<%=getCSSClassValue("password", accountPrefsPage)%>">Password</a></li>
	<span class="selectedDivider">|</span>
	<li><a href="<dtpc:getDesktopURL/>?provider=AccountPreferencesContainer&accountPrefsPage=contactinfo&last=false" class="<%=getCSSClassValue("contactinfo", accountPrefsPage)%>" title="Click to navigate to this item">Contact Information</a></li>
	<span class="selectedDivider">|</span>
	<li><a href="<dtpc:getDesktopURL/>?provider=AccountPreferencesContainer&accountPrefsPage=timezone&last=false" class="<%=getCSSClassValue("timezone", accountPrefsPage)%>" title="Click to navigate to this item">Time Zone</a></li>
	<span class="selectedDivider">|</span>
      </div> 
    </td> 
    <td nowrap width="40%">
      <div id="secondaryContainerNavigation" style="text-align:right">
        <span class="selectedDivider">|</span>
	<li><a href="javascript:void(0)" title="Click to launch help in a new browser window" class="Unselected" onClick="javascript:openWindow('<dtpc:getDesktopURL/>?provider=OnlineHelpContainer&topic=accountPreferences&last=false','Help');">Help</a></li>
	<span class="selectedDivider">|</span>
      </div>
    </td> 
    </tr> 
    
    </table> 
    <!-- End Secondary Tab Navigation --> 
  </div> 

  <!-- This is the target anchor used to skip repetitive navigation links for users of screen readers -->
  <div><a name="goto-body" id="goto-body"></a></div>

  <div class="preferencesPageContainer">
      
    <!-- Begin Channel -->
    <div id="channel" class="channel"> 
      

      <table cellpadding="0" cellspacing="0" border="0" width="100%" class="channelBackground"> 
      <tr><td><img src="<dt:scontent/>/enterprise/images/spacer.gif" alt="" width="1" height="5"></td></tr>
      <tr><td><div class="channelTitleText">Change <%=titles.get(accountPrefsPage)%></div></td></tr> 
      </table> 
  
      <div><img src="<dt:scontent/>/enterprise/images/spacer.gif" alt="" width="1" height="10"></div>

      <%
      /*
       * This url is also the return url of the included forms process action and so
       * given the state html about the result of the process action may get included.
       */
       String accountPrefsState = null;
       if (session.getAttribute( "accountPrefsState" ) != null &&
           !session.getAttribute( "accountPrefsState" ).equals(INCOMPLETE)) {
	   accountPrefsState = (String)session.getAttribute( "accountPrefsState" );
	   String accountPrefsStatePageContent = accountPrefsPage + "/" + accountPrefsState + ".jsp";
       %>
        <%-- Include info about result of pressing "Save Changes" button. --%>
        <jsp:include page="<%=accountPrefsStatePageContent%>" flush="true"/>
      <%
      }
      %>

      <!-- include page with javascript for client-side form validation -->
      <jsp:include page="<%=accountPrefsFormValidation%>" flush="true"/>

      <form action="<dtpc:getDesktopURL/>?provider=AccountPreferencesContainer&last=false" 
            target="_parent" method="POST" name="contentForm" 
            enctype="application/x-www-form-urlencoded">
           <input type=hidden name="action" size=-1 value="process">
           <input type=hidden name="provider" size=-1 value="AccountPreferencesContainer">
           <input type=hidden name="accountPrefsPage" size=-1 value="<%=accountPrefsPage%>">

	   <table cellpadding="0" cellspacing="0" border="0" >
	   
	     <jsp:include page="<%=accountPrefsPageContent%>" flush="true"/>

	     <tr><td><img src="<dt:scontent/>/enterprise/images/spacer.gif" alt="" width="1" height="10"></td></tr>
	     
	     <tr><td width="100%" class="channelBorder"><img src="<dt:scontent/>/enterprise/images/spacer.gif" alt="" width="1" height="1"></td></tr>
           
	   <tr>
           <td align="right" valign="top">
           <div class="buttonRow">
             <input style="vertical-align: middle" class="defaultButton" type="button" name="save" id="save" value="Save Changes" onMouseOver="if (this.disabled==0) this.className='defaultButtonHover'" onFocus="if (this.disabled==0) this.className='defaultButtonHover'" onMouseOut="if (this.disabled==0) this.className='defaultButton'" onBlur="if (this.disabled==0) this.className='defaultButton'" onClick="if (contentFormValid()) this.form.submit();" onKeyPress="if (contentFormValid()) this.form.submit();" title="Save Changes Button"/>
	     <img src="<dt:scontent/>/enterprise/images/spacer.gif" alt="" width="5" height="1">
             <input style="vertical-align: middle" class="button" type="reset" name="reset" id="reset" value="Reset" onMouseOver="if (this.disabled==0) this.className='buttonHover'" onFocus="if (this.disabled==0) this.className='buttonHover'" onMouseOut="if (this.disabled==0) this.className='button'" onBlur="if (this.disabled==0) this.className='button'" onClick="" onKeyPress="" title="Reset Button"/>
             <img src="<dt:scontent/>/enterprise/images/spacer.gif" alt="" width="5" height="1">
             <input style="vertical-align: middle" class="button" type="button" name="finished" id="finished" value="Finished" onMouseOver="if (this.disabled==0) this.className='buttonHover'" onFocus="if (this.disabled==0) this.className='buttonHover'" onMouseOut="if (this.disabled==0) this.className='button'" onBlur="if (this.disabled==0) this.className='button'" onClick="location.href='<dtpc:getDesktopURL/>?action=content&provider=ASCTabContainer'" onKeyPress="location.href='<dtpc:getDesktopURL/>?action=content&provider=ASCTabContainer'" title="Finished Button"/>
	   </div>
           </td>
           </tr>
           </table>
      </form>
    </div>
  </div>

  <%
    /* The state must be reset so the next time through the state is not the "old" state. */
    session.setAttribute("accountPrefsState", INCOMPLETE);
  %>
  
</dt:obtainContainer>
