<%@ page import="
java.util.*,
com.iplanet.sso.*,
com.iplanet.am.sdk.*,
com.iplanet.am.util.*,
com.sun.identity.security.AdminTokenAction,
java.security.AccessController"%><%

%><%@ taglib uri="/tld/desktop.tld" prefix="dt" %><%
%><%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc"%><%

%>
<%!
// This JSP is responsible for displaying the search results based on the 
// search criteria for finding an employee within an organization.
//
AMStoreConnection amsc = null;

/*
 * Responsible for obtaining a connection to the Sun Java System 
 * Identity Server data store.  The connection is established with
 * the admin credentials.
 * 
 * @return AMStoreConnection
 * @throws Exception
 */
public AMStoreConnection getAdminConnection() throws Exception {
    SSOTokenManager ssom = SSOTokenManager.getInstance();
    SSOToken adminToken =
        (SSOToken)AccessController.doPrivileged(AdminTokenAction.getInstance());
  return new AMStoreConnection(adminToken);
}

/*
 * Responsible for retrieving the user's within the organization
 * AMConstants.SCOPE_SUB that match the employee search criteria.
 * The List that is returned contains AMSearchResults objects if 
 * a match is found.
 *
 * @param  connection           the AMStoreConnection
 * @param  employeeSearchKey    the user attribute to search
 * @param  employeeSearchValue  the user attribute value to search
 * @param  returnAttribute      the return attributes (for display)
 *
 * @return List of AMSearchResults
 * @throws Exception
 */
public AMSearchResults getSearchResults(AMStoreConnection connection,
                             String employeeSearchKey,
                             String employeeSearchValue,
                             Set returnAttributes) throws Exception {

	// Restrict search to adventuresportscafe.com org
	AMOrganization amOrganization = connection.getOrganization(connection.getOrganizationDN("@SAMPLE_ORG@",null));

    Map avMap = new HashMap();
    Set avSet = new HashSet();

    avSet.add(employeeSearchValue + "*");
    avMap.put(employeeSearchKey, avSet);

    AMSearchControl searchControl = new AMSearchControl();
    searchControl.setSearchScope(AMConstants.SCOPE_SUB);
    searchControl.setReturnAttributes(returnAttributes);

    AMSearchResults results = amOrganization.searchUsers("*",
                                                         avMap,
                                                         searchControl);
	return results;
}


/*
 * Responsible for returning an attribute value.
 * 
 * @param  userDN    the user's DN found in the <code>usersMap</code>  
 * @param  usersMap  the Map of user DNs from the search result 
 * @param  attrName  the attribute whose value is to be returned 
 * 
 * @return String representing an an attribute value
 * @throws Exception
 */
public String getAttributeValue(String userDN, 
                                Map usersMap, 
                                String attrName) {

    // get user's attribute map from user dn result map
    // 
    Map userAttrMap = (Map)usersMap.get(userDN);
    if (userAttrMap == null) {
        return "";
    }

    // get attribute value (set) from the user's attributes
    // 
    Set attrValues = (Set)userAttrMap.get(attrName);
    if (attrValues == null || attrValues.isEmpty()) {
        return "";
    }

    // concatenate all the values
    // 
    StringBuffer sb = new StringBuffer();
    Iterator iter = attrValues.iterator();

    while (iter.hasNext()) {
        sb.append((String)iter.next() + " ");
    }

  return sb.toString();
}

%>
<%
// define the attributes to be returned by the search
//
Set returnAttributes = new HashSet();
returnAttributes.add("givenname");
returnAttributes.add("sn");
returnAttributes.add("uid");
returnAttributes.add("mail");
returnAttributes.add("telephonenumber");

// retrieve the search key and search value from the request
//
String employeeSearchKey   = (String)request.getParameter("employeeSearchKey");
String employeeSearchValue = (String)request.getParameter("employeeSearchValue");

// check for AMStoreConnection
// 
if (amsc == null) {
  amsc = getAdminConnection();
}

// retrieve the search results
// 
AMSearchResults searchResults  = getSearchResults(amsc, 
                                    employeeSearchKey, 
                                    employeeSearchValue, 
                                    returnAttributes);

// process the result set for display
//
Boolean headerPrinted=false;
Set users    = searchResults.getSearchResults();
Map usersMap = searchResults.getResultAttributes();
int cnt =0;

for (Iterator iter2=users.iterator(); iter2.hasNext(); ) {
    String userDN    = (String) iter2.next();

    // filter out authless user
    if (userDN.indexOf("@ENTERPRISE_SAMPLE_AUTHLESS_UID@") != -1) {
        continue;
    }
	
	if (!headerPrinted) { %>
<table cellspacing="0" cellspacing="0" width="100%">
<tr>
    <th>Employee</th>
    <th>Telephone</th>
</tr>

<%
		headerPrinted=true;
	}
    String givenname = getAttributeValue(userDN, usersMap, "givenname");
    String sn        = getAttributeValue(userDN, usersMap, "sn");
    String mail      = getAttributeValue(userDN, usersMap, "mail");
    String telephonenumber = getAttributeValue(userDN, usersMap, "telephonenumber");
    String rowClass  = (cnt%2 ==0)?"even":"odd";
%>
<tr class="<%=rowClass%>">
    <td><a href="mailto:<%=mail%>"><%=givenname%> <%=sn%></a></td>
    <td><%=telephonenumber%></td>
</tr>
<%
    cnt++;
} 

if (!headerPrinted){ %>

  <b>No employees found.</b><br> 

<% } else { %>

</table>
<% } %>

<dt:obtainChannel channel="$JSPProvider">
<br>
<%@ include file="searchForm.jsp" %>
</dt:obtainChannel>
