<%@ page import="java.util.*, com.sun.portal.providers.*, com.sun.portal.providers.jsp.*"%>
<%@ taglib uri="/tld/jx.tld" prefix="jx" %>
<%@ taglib uri="/tld/desktop.tld" prefix="dt" %>
<%@ taglib uri="/tld/desktopProviderContext.tld" prefix="dtpc" %>
<%
// This JSP is responsible for displaying a table of data where one of
// the table cells contains a link which displays the content in the 
// full page view when selected.
//
// The channel type is "table".  The table data is retrieved from
// a global display profile collection named the same as the channel.
// Within this collection there is an inner collection named "data" which
// contains 1..N collections of data.  
//
// Each collection has the following required properties:
//
// * title    : link display text
// * doc      : location of the complete content document
//
// the following properties are optional
//
// * doc_type : if the type is external, then the link is not
//              displayed within the portal desktop.
//
// For example,
//
// <Collection name="FooChannel">
//     <Collection name="data">
//         <Collection name="1">
//             <String name="title" value="Foo Link Title"/>
//             <String name="doc" value="FooChannelContent.html"/>
//             <String name="data1" value="Data 1"/>
//             <String name="data2" value="Data 2"/>
//          </Collection>
//      </Collection>
//  </Collection>
//
// The channel specifies the table layout
//
// <String name="columncount" value="3" />
// <String name="columndisplay1" value="Column Display 1" />
// <String name="columnkey1" value="doc" />
// <String name="columndisplay2" value="Column Display 2" />
// <String name="columnkey2" value="data2" />
// <String name="columndisplay3" value="Column Display 3" />
// <String name="columnkey3" value="data3" />
JSPProvider jp = (JSPProvider)pageContext.getAttribute("JSPProvider");
String fullChannelName = jp.getName();
String channelName     = fullChannelName;
String desktopURL      = jp.getProviderContext().getDesktopURL(request);
int index              = channelName.indexOf("/");
if (index != -1) {
    channelName = channelName.substring(index+1);
}
// retrieve "data" collection from the global collection based on the
// channel name
Map globalChannelCollection = jp.getMapProperty(channelName);
Map data     = (Map)globalChannelCollection.get("data");
Iterator itr = data.keySet().iterator();
// retrieve the table column count from the channel
String columnCountStr = jp.getStringProperty("columncount", "1");
int columnCount       = Integer.parseInt(columnCountStr);
%>
<dt:obtainChannel channel="$JSPProvider">
<table cellpadding="0" cellspacing="0" border="0" width="100%">
<tr valign="top">
<%
// retrieve the table headers based on the "columndisplay"
// channel display profile property
for (int i=1; i<=columnCount; i++) {
    String display = jp.getStringProperty("columndisplay" + i, "");
%>
<th nowrap><%=display%></th>
<% } %>
</tr>
<%
while (itr.hasNext()) {
    String dataKey  = (String)itr.next();
    Map row         = (Map)data.get(dataKey);
    String title    = "";
    StringBuffer query = new StringBuffer();
%>
<tr valign="bottom">
<%
    // retrieve the table data based on the "columnkey" and "columncount"
    // channel display profile properties
    //
    for (int i=1; i<=columnCount; i++) {
        String columnKey  = jp.getStringProperty("columnkey" + i, "");
        String columnData = (String)row.get(columnKey);
        if (columnKey.equals("doc")) {
            title = (String)row.get("title");
            query.append(desktopURL)
                 .append("?action=content")
                 .append("&channel=")
                 .append(fullChannelName)
                 .append("&provider=FullPageContainer")
                 .append("&last=false")
                 .append("&mode=full")
                 .append("&doc=")
                 .append(columnData);
%>
    <td nowrap><a href="<%=query%>"><%=title%></a></td>
<%      } else { %>
    <td nowrap><%=columnData%></td>
<%      } 
    } // end for 
%>
    </tr>
<%
} // end while 
%>
</table>
</dt:obtainChannel>
