create table surveys(
survey_id int not null generated always as identity primary key,
survey_name varchar(200) not null,
survey_description varchar(400) not null,
survey_owner char(100) not null,
survey_type char(10) not null,
community_id char(150) not null,
start_date date,
end_date date);

create table questions(
question_id int not null generated always as identity primary key,
survey_id int not null,
question_order int not null,
question_text varchar(400) not null,
is_mandatory smallint,
has_open_answer smallint,
is_multiselect smallint,
foreign key(survey_id) references surveys(survey_id));

create table answers(
answer_id int not null generated always as identity primary key,
question_id int not null references questions(question_id),
answer_order integer,
answer_text varchar(400));


create table responses(
response_id int not null generated always as identity primary key,
question_id int not null references questions(question_id),
survey_id int not null references surveys(survey_id),
answer_id int references answers(answer_id),
user_id char(100) not null,
response_date date not null default current_date,
open_answer varchar(400));

