<%@ page errorPage="/jsp/default/errorpage.jsp" %><%
%><%@ taglib uri="/WEB-INF/wireless_util.tld" prefix="util" %><%
%><%@ taglib uri="/WEB-INF/wireless_mail.tld" prefix="mail" %><%
%><util:nocache/><util:content type="text/plain" /><%
%><?xml version="1.0"?>
<util:include file="docTypeDeclaration.jsp" comp="common"/>

<%-- 
  Copyright 2003 Sun Microsystems, Inc. All Rights Reserved.
  Use is subject to license terms.
--%>

<%--
  playMessageHeader.jsp will read out the header informaiton of the requested 
  mail message.
  
  Input parameters:
    JSP:
      msgIndex          - Index of the requested message
      msgType           - Type of the requested message
      
    VoiceXML:
      p_path            - The complete path to the prompt files.

  Output parameters:
    VoiceXML:
      msgIndexAsInteger - Integer value of the input msgIndex

  Application root document:
    mailRoot.jsp

  Invoked by:
    mailApp.jsp 
--%>

<%
  // get the index of the message whose headers need to be read out
  String number_as_string = request.getParameter("msgIndex");

  String number_as_integer_string = null;
  try {
    Integer integer = new Integer(number_as_string);
    number_as_integer_string = integer.toString();
  } catch (NumberFormatException e) {
    Float aFloat = new Float(number_as_string);
    number_as_integer_string = Integer.toString(aFloat.intValue());
  }

  pageContext.setAttribute("msgIndexAsInteger", number_as_integer_string);
%>

<mail:context/>

<vxml version="2.0" application="<util:url file="dialogs/mailRoot.jsp" comp="mail"/>">

  <var name="msgIndexAsInteger" expr="<%= number_as_integer_string %>"/>

  <form id="main">
    <%-- passed in via a subdialog --%>
    <var name="p_path"/>

    <block>
      <assign name="prompt_path" expr="p_path"/>
      <goto next="#play_message_header"/>
    </block>
  </form>

  <%-- 2.12 Play Message Header --%>
  <form id="play_message_header">
    <mail:messages id="msgs">
      <var name="size" expr="<mail:get property="size"/>"/>
      
      <util:set property="start" id="msgIndexAsInteger" />
      <util:set property="count" value="1" />

      <var name="speakNum" expr="<util:get property="startOne"/>"/>
    </mail:messages>
    
    <subdialog name="msg_number" src="<util:url file="dialogs/speakMessageNumber.jsp" comp="mail"/>" namelist="speakNum">
      <param name="msg_type"    value="<%= request.getParameter("msgType") %>"/>
      <param name="prompt_path" expr="prompt_path"/>
    </subdialog>
    
    <mail:messages name="msgs" iterate="true">
      <mail:message id="currentMsg">
    
        <mail:get property="deleted" id="isDeleted"/>
        <util:if property="deleted" value="true" >
          <block name="deleted">
            <prompt>
              <audio expr="prompt_path + 'marked_for_deletion.wav'"/>
            </prompt>
          </block>
        </util:if> 

        <block name="sender">
          <prompt>
            <audio expr="prompt_path + 'from.wav'"/>
<%
            /*
             * If fromPersonal is not set in the message this tag will throw
             * a NullPointerException. If fromPersonal is not present we'll
             * then use fromAddress value.
             */
            try {
%>
              <mail:get property="fromAddress" id="fromAddress"/>
              <mail:get property="fromPersonal" id="from"/>
<%
            } catch (NullPointerException ne) {
              String fromAddress = (String) pageContext.getAttribute("fromAddress");
              pageContext.setAttribute("from", fromAddress);
            }
%>
            <%= pageContext.getAttribute("from") %>
          </prompt>
        </block>

        <block name="subject">
            <mail:get property="subject" id="subj"/>
<%
            String unescSubj = (String) pageContext.getAttribute("subj");
            if (unescSubj != null && unescSubj.length() > 0) {
               String escSubj = unescSubj.replaceAll("&", "&amp;");
               escSubj = escSubj.replaceAll("<", "&lt;");
               pageContext.setAttribute("subj", escSubj);
            }
%>
            <script>
               <![CDATA[
                  var finalSubj = ' <%= pageContext.getAttribute("subj") %> ' ;
               ]]>
            </script>
          <prompt>
            <audio expr="prompt_path + 'subject.wav'"/>
            <value expr="finalSubj"/>
          </prompt>
        </block>
        
        <var name="speakDate" expr="'<mail:get property="date" />'" />
        <subdialog name="date" src="<util:url file="dialogs/SpeakDate.jsp" comp="common"/>" namelist="speakDate">
          <param name="prompt_path" expr="prompt_path"/>
        </subdialog>

      </mail:message>
    </mail:messages>
    
    <block name="last_message" cond="speakNum == size">
      <prompt>
        <audio expr="prompt_path + 'to_hear_the_whole_message_say_read_it.wav'"/>
      </prompt>
    </block>

    <block>
      <goto next="#go_back_to_caller"/>
    </block>
  </form>
  
  <form id="go_back_to_caller">
    <block>
      <return namelist="msgIndexAsInteger"/>
    </block>
  </form>
</vxml>
