<%@ page errorPage="/jsp/default/errorpage.jsp" %><%
%><%@ taglib uri="/WEB-INF/wireless_util.tld" prefix="util" %><%
%><%@ taglib uri="/WEB-INF/wireless_mail.tld" prefix="mail" %><%
%><util:nocache/><util:content type="text/plain" /><%
%><?xml version="1.0"?>
<util:include file="docTypeDeclaration.jsp" comp="common"/>

<%-- 
  Copyright 2003 Sun Microsystems, Inc. All Rights Reserved.
  Use is subject to license terms.
--%>

<%--
  This is the main entry point for the mail voicelet.
  
  This dialog is entered after voicelet initialization 
  (MailLoad.jsp) and implements the main menu of the voicelet. 
  Voicelet-specific commands are dispatched from this dialog.

  This dialog must be invoked as the result of a <subdialog> 
  tag and must perform a <return/> upon completion.

  Input parameters:
    VoiceXML:
      p_root - root location of prompts for this voicelet
      p_persona - the prompt persona for this dialog

  Output parameters:
    VoiceXML:
      response 
      readaction 

  Application root document:
    mailRoot.jsp

  Invoked by:
    launchVoicelet.jsp
--%>

<%
  boolean mailVoiceletAlreadyLoaded = false;

  try {
    if (session.getAttribute("mailLoadedByVoicelet") != null) {
      mailVoiceletAlreadyLoaded = true;
    } else {
      session.setAttribute("mailLoadedByVoiclet", "true");
    }
  } catch (Exception e) {
  }
%>

<vxml version="2.0" application="<util:url file="dialogs/mailRoot.jsp" comp="mail"/>">

  <!-- document functions -->

  <!-- document variables -->
  <var name="mailVoiceletAlreadyLoaded" expr="'<%= (mailVoiceletAlreadyLoaded)? "true" : "false" %>'"/>
  
  <var name="numMsgs"       expr="0"/>
  <var name="numRead"       expr="0"/>
  <var name="numUnread"     expr="0"/>
  <var name="numUserUnread" expr="0"/>
  
  <var name="msgType"                expr="'unread'"/>
  <var name="numMsgsOfGivenType"     expr="0"/>

  <var name="msgIndex"               expr="0"/>
  
  <var name="userInput"              expr="''"/>
  <var name="sayFirst"               expr="'false'"/>
  <var name="msgBodyHasBeenHeard"    expr="'false'"/>

  <var name="looped"                 expr="'false'"/>

  <%-- Document grammar --%>
  <link event="whatAreMyChoices">
    <grammar src="<util:url file="grammars/email.grammar" comp="mail" compress="false" includeSid="false"/>#Choices"/>
  </link>

  <%-- Main page entry point, initializes application --%>
  <form id="initialize_email_voicelet">
    <%-- subdialog parameters --%>
    <var name="p_root"/>
    <var name="p_persona"/>

    <block>
      <%-- The following needs to be done only once per application --%>
      <assign name="prompt_root" expr="p_root"/>
      <assign name="persona"     expr="p_persona"/>

      <assign name="prompt_path" expr="prompt_root + '/' + persona + '/'"/>
      <log label="trace:?level=STATUS" expr="'MailApp.jsp#initialize_mail_voicelet; prompt_path=' + prompt_path"/>
      <goto next="#start_of_email_channel"/>
    </block>
  </form>

  <%-- 2.1 Start of E-mail Channel --%>
  <form id="start_of_email_channel">
    <mail:context>
      <%-- the total number of messages --%>
      <var name="numMsgs" expr="<mail:get property="numMsgs"/>" />
    </mail:context>

    <block>
      <if cond="numMsgs == 0">
        <goto next="#no_messages"/>
      <else/>
        <if cond="mailVoiceletAlreadyLoaded == 'false'">
          <goto next="#load_email_channel_and_message_summary"/>
        <else/>
          <goto next="#email_menu"/>
        </if>
      </if>
    </block>
  </form>

  <%-- 2.2 Load E-mail Channel and Message Summary --%>
  <form id="load_email_channel_and_message_summary">
    <block>
      <audio expr="prompt_path + 'ok.wav'"/>
      <goto next="#play_summary"/>
    </block>
  </form>
  
  <%-- 2.4 Play Summary --%>
  <form id="play_summary">
    <var name="speakNum" expr="0"/>

    <subdialog name="summary" src="<util:url file="dialogs/getMailSummary.jsp" comp="mail"/>">
      <filled>
        <assign name="numMsgs"       expr="summary.numMsgs"/>
        <assign name="numRead"       expr="summary.numRead"/>
        <assign name="numUnread"     expr="summary.numUnread"/>
        <assign name="numUserUnread" expr="summary.numUserUnread"/>

        <assign name="numMsgsOfGivenType" expr="numUnread"/>
      </filled>
    </subdialog>

    <block name="no_msgs" cond="numMsgs == 0">
      <goto next="#no_messages"/>
    </block>

    <block name="unread_msgs" cond="numUnread &gt; 0">
      <if cond="numUnread == 1">
        <if cond="numUserUnread + numRead == 0">
          <prompt>
            <audio expr="prompt_path + 'you_have_1_unread_message_fin.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'you_have_1_unread_message_mid.wav'"/>
          </prompt>
        </if>
      <else/>
        <prompt>
          <audio expr="prompt_path + 'you_have.wav'"/>
        </prompt>

        <%-- Play this number now as shown in the next subdialog --%>
        <assign name="speakNum" expr="numUnread"/>
      </if>
    </block>

    <subdialog name="num_unread_msgs" 
               cond="numUnread &gt; 1" 
               src="<util:url file="dialogs/SpeakNumber.jsp" comp="common"/>" 
               namelist="speakNum">
      <param name="prompt_path" expr="prompt_path"/>
      <filled>
        <if cond="numUserUnread + numRead == 0">
          <prompt>
            <audio expr="prompt_path + 'unread_messages_fin.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'unread_messages_mid.wav'"/>
          </prompt>
        </if>
      </filled>
    </subdialog>

    <block name="your_unread_msgs" cond="numUserUnread &gt; 0">
      <if cond="numUserUnread == numUnread">
        <if cond="numRead == 0">
          <prompt>
            <audio expr="prompt_path + 'all_of_them_addressed_to_you_fin.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'all_of_them_addressed_to_you_mid.wav'"/>
          </prompt>
        </if>
      <else/>
        <assign name="speakNum" expr="numUserUnread"/>
      </if>
    </block>

    <subdialog name="num_your_unread_msgs" 
               cond="numUserUnread &gt; 0 &amp;&amp; numUserUnread != numUnread" 
               src="<util:url file="dialogs/SpeakNumber.jsp" comp="common"/>" 
               namelist="speakNum">
      <param name="prompt_path" expr="prompt_path"/>
      <filled>
        <if cond="numRead == 0">
          <prompt>
            <audio expr="prompt_path + 'of_them_addressed_to_you_fin.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'of_them_addressed_to_you_mid.wav'"/>
          </prompt>
        </if>
      </filled>
    </subdialog>

    <block name="read_msgs" cond="numRead &gt; 0">
      <if cond="numRead == 1">
        <if cond="numUnread == 0">
          <prompt>
            <audio expr="prompt_path + 'you_have_1_read_message_fin.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'and_you_have_1_read_message_fin.wav'"/>
          </prompt>
        </if>
      <else/>
        <if cond="numUnread == 0">
          <prompt>
            <audio expr="prompt_path + 'you_have.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'and_you_have.wav'"/>
          </prompt>
        </if>

        <%-- Play this number now as shown in the next subdialog --%>
        <assign name="speakNum" expr="numRead"/>
      </if>
    </block>

    <subdialog name="num_read_msgs" 
               cond="numRead &gt; 1" 
               src="<util:url file="dialogs/SpeakNumber.jsp" comp="common"/>" 
               namelist="speakNum">
      <param name="prompt_path" expr="prompt_path"/>
      <filled>
        <prompt>
          <audio expr="prompt_path + 'read_messages_fin.wav'"/>
        </prompt>
      </filled>
    </subdialog>

    <block>
      <if cond="numUnread != 0 &amp;&amp; mailVoiceletAlreadyLoaded == 'false'">
        <goto next="#load_requested_message_list"/>
      <else/>
        <goto next="#email_menu"/>
      </if>
    </block>
  </form>

  <%-- 2.5 E-mail Menu --%>
  <form id="email_menu">
    <field name="option" slot="option">
      <grammar src="<util:url file="grammars/email.grammar" comp="mail" compress="false" includeSid="false"/>#MessageTypeAction"/>

      <prompt cond="looped == 'true'" bargein="true">
        <audio expr="prompt_path + 'youre_back_at_the_e_mail_menu.wav'"/>
        <audio expr="prompt_path + 'you_can_say_list_unread_messages_list_read_message.wav'"/>
      </prompt>

      <prompt cond="looped == 'false'" bargein="true">
        <audio expr="prompt_path + 'youre_at_the_e_mail_menu.wav'"/>
        <audio expr="prompt_path + 'you_can_say_list_unread_messages_list_read_message.wav'"/>
      </prompt>

      <nomatch count="1">
        <prompt bargein="true">
          <audio expr="prompt_path + 'sorry_i_didnt_get_that.wav'"/>
          <audio expr="prompt_path + 'tell_me_which_message_list_you_want_or_if_youre_do.wav'"/>
        </prompt>
      </nomatch>

      <nomatch count="2">
        <prompt bargein="true">
          <audio expr="prompt_path + 'sorry_i_still_didnt_get_that.wav'"/>
          <audio expr="prompt_path + 'you_can_ask_for_any_of_these_message_lists_unread_.wav'"/>
        </prompt>
      </nomatch>

      <noinput count="1">
        <prompt bargein="true">
          <audio expr="prompt_path + 'sorry_i_didnt_hear_anything.wav'"/>
          <audio expr="prompt_path + 'tell_me_which_message_list_you_want_or_if_youre_do.wav'"/>
        </prompt>
      </noinput>

      <noinput count="2">
        <prompt bargein="true">
          <audio expr="prompt_path + 'sorry_i_still_didnt_hear_anything.wav'"/>
          <audio expr="prompt_path + 'you_can_ask_for_any_of_these_message_lists_unread_.wav'"/>
        </prompt>
      </noinput>

      <help>
        <prompt bargein="true">
          <audio expr="prompt_path + 'ok_heres_some_help.wav'"/>
          <audio expr="prompt_path + 'you_can_ask_for_any_of_these_message_lists_unread_.wav'"/>
        </prompt>
      </help>

      <catch event="whatAreMyChoices">
        <prompt bargein="true">
          <audio expr="prompt_path + 'here_are_your_choices.wav'"/>
          <audio expr="prompt_path + 'you_can_ask_for_any_of_these_message_lists_unread_.wav'"/>
        </prompt>
      </catch>

      <filled>
        <assign name="looped" expr="'true'"/>

        <assign name="userInput" expr="option"/>
        <goto next="#handle_user_input"/>
      </filled>
    </field>
  </form>

  <%-- 2.6 Acknowledge Requested E-mail Menu --%>
  <form id="acknowledge_requested_email_menu">
    <block>
      <assign name="mailVoiceletAlreadyLoaded" expr="'true'"/>
		  
      <audio expr="prompt_path + 'ok.wav'"/>
      <goto next="#email_menu"/>
    </block>
  </form>

  <%-- 2.7 No Messages of Requested Type --%>
  <form id="no_messages_of_requested_type">
    <block>
      <if cond="msgType == 'unread'">
        <audio expr="prompt_path + 'sorry_but_you_dont_have_any_unread_messages.wav'"/>
      <elseif cond="msgType == 'unreadAddrToMe'"/>
        <audio expr="prompt_path + 'sorry_but_you_dont_have_any_unread_messages_addres.wav'"/>
      <elseif cond="msgType == 'read'"/>
        <audio expr="prompt_path + 'sorry_but_you_dont_have_any_read_messages.wav'"/>
      </if>

      <goto next="#email_menu"/>
    </block>
  </form>

  <%-- 2.8 Load Requested Message List --%>
  <form id="load_requested_message_list">

    <subdialog name="load" src="<util:url file="dialogs/fetchMessages.jsp" comp="mail"/>" namelist="msgType">

      <filled>
        <assign name="numMsgsOfGivenType" expr="load.numMsgs"/>
        <assign name="sayFirst" expr="'false'"/>

        <if cond="numMsgsOfGivenType == 0">
          <goto next="#no_messages_of_requested_type"/>
        <else/>
          <goto next="#pre_message_list"/>
        </if>
      </filled>
    </subdialog>
   
  </form>

  <%-- 2.9 Pre Message List --%>
  <form id="pre_message_list">
    <var name="audioFile"     expr="''"/>
    <var name="speakNum"      expr="0"/>

    <block cond="mailVoiceletAlreadyLoaded == 'false'">
      <if cond="numUnread == 1">
        <if cond="numRead == 0">
          <prompt>
            <audio expr="prompt_path + 'here_it_is.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'heres_the_unread_message.wav'"/>
          </prompt>
        </if>
      <elseif cond="numUnread &gt; 1"/>
        <if cond="numRead == 0">
          <prompt>
            <audio expr="prompt_path + 'ill_list_them_for_you.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'ill_give_you_the_list_of_unread_messages.wav'"/>
          </prompt>
        </if>

        <prompt>
          <audio expr="prompt_path + 'at_any_time_you_can_say_next_read_it_or_what_are_m.wav'"/>
        </prompt>
      </if>
    </block>

    <block cond="mailVoiceletAlreadyLoaded == 'true'">
      <prompt>
        <audio expr="prompt_path + 'all_right.wav'"/>
      </prompt>

      <assign name="speakNum"  expr="numMsgsOfGivenType"/>

      <%-- User specifically requested unread messages --%>
      <if cond="msgType == 'unread'">
        <if cond="numMsgsOfGivenType == 1">
          <prompt>
            <audio expr="prompt_path + 'heres_the_header_for_your_1_unread_message.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'ill_list_your.wav'"/>
          </prompt>

          <assign name="audioFile" expr="'unread_messages.wav'"/>
        </if>
      </if>

      <%-- User specifically requested read messages --%>
      <if cond="msgType == 'read'">
        <if cond="numMsgsOfGivenType == 1">
          <prompt>
            <audio expr="prompt_path + 'heres_the_header_for_your_1_read_message.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'ill_list_your.wav'"/>
          </prompt>

          <assign name="audioFile" expr="'read_messages.wav'"/>
        </if>
      </if>

      <%-- User specifically requested unread messages addressed to him --%>
      <if cond="msgType == 'unreadAddrToMe'">
        <if cond="numMsgsOfGivenType == 1">
          <prompt>
            <audio expr="prompt_path + 'heres_the_header_for_the_1_unread_message_addresse.wav'"/>
          </prompt>
        <else/>
          <prompt>
            <audio expr="prompt_path + 'ill_list_the.wav'"/>
          </prompt>

          <assign name="audioFile" expr="'unread_messages_addressed_to_you.wav'"/>
        </if>
      </if>
    </block>

    <subdialog cond="speakNum &gt; 1" src="<util:url file="dialogs/SpeakNumber.jsp" comp="common"/>" namelist="speakNum">
      <param name="prompt_path" expr="prompt_path"/>
      <filled>
        <prompt>
          <audio expr="prompt_path + audioFile"/>
        </prompt>
      </filled>
    </subdialog>

    <block>
      <assign name="mailVoiceletAlreadyLoaded" expr="'true'"/>
      <goto next="#move_to_first_item"/>
    </block>
  </form>

  <%-- 2.10 Move to First Item --%>
  <form id="move_to_first_item">
    <block>
      <assign name="msgIndex" expr="0"/>
      <goto next="#announce_first_message"/>
    </block>
  </form>

  <%-- 2.11 Announce First Message --%>
  <form id="announce_first_message">
    <block>
      <if cond="sayFirst == 'true'">
        <audio expr="prompt_path + 'heres_the_first_one_again.wav'"/>
      <else/>
        <assign name="sayFirst" expr="'true'"/>
      </if>

      <goto next="#play_message_header"/>
    </block>
  </form>

  <%-- 2.12 Play Message Header --%>
  <form id="play_message_header">
    <subdialog name="play_header" src="<util:url file="dialogs/playMessageHeader.jsp" comp="mail"/>" namelist="msgIndex msgType">
      <param name="p_path" expr="prompt_path"/>

      <filled>
        <assign name="msgIndex" expr="play_header.msgIndexAsInteger"/>

        <assign name="msgBodyHasBeenHeard" expr="'false'"/>
        <goto next="#listen_for_user_input"/>
      </filled>
    </subdialog>
  </form>

  <%-- 2.13 Listen for User Input --%>
  <form id="listen_for_user_input">
    <property name="timeout" value="4s"/>

    <field name="option" slot="option">
      <grammar src="<util:url file="grammars/email.grammar" comp="mail" compress="false" includeSid="false"/>#MessageAction"/>

      <noinput>
        <assign name="userInput" expr="''"/>
        <goto next="#handle_user_input"/>
      </noinput>

      <nomatch count="1">
        <prompt bargein="true">
          <audio expr="prompt_path + 'sorry_i_didnt_get_that.wav'"/>
          <audio expr="prompt_path + 'say_read_it_repeat_it_or_next_or_say_what_are_my_c.wav'"/>
        </prompt>
      </nomatch>

      <nomatch count="2">
        <prompt bargein="true">
          <audio expr="prompt_path + 'sorry_i_still_didnt_get_that.wav'"/>
          <audio expr="prompt_path + 'after_each_message_you_can_say_read_it_delete_it_o.wav'"/>
        </prompt>
      </nomatch>

      <help>
        <prompt bargein="true">
          <audio expr="prompt_path + 'ok_heres_some_help.wav'"/>
          <audio expr="prompt_path + 'after_each_message_you_can_say_read_it_delete_it_o.wav'"/>
        </prompt>
      </help>

      <catch event="whatAreMyChoices">
        <prompt bargein="true">
          <audio expr="prompt_path + 'here_are_your_choices.wav'"/>
          <audio expr="prompt_path + 'after_each_message_you_can_say_read_it_delete_it_o.wav'"/>
        </prompt>
      </catch>

      <filled>
        <assign name="userInput" expr="option"/>
        <goto next="#handle_user_input"/>
      </filled>
    </field>
  </form>

  <%-- Handles user input --%>
  <form id="handle_user_input">
    <block>
      <if cond="userInput == '' || userInput == 'next'">
        <goto next="#move_to_next_list_item"/>
      <elseif cond="userInput == 'delete'"/>
        <goto next="#confirm_deleting_message"/>
      <elseif cond="userInput == 'read'"/>
        <goto next="#read_message_body"/>
      <elseif cond="userInput == 'first'"/>
        <goto next="#move_to_first_item"/>
      <elseif cond="userInput == 'last'"/>
        <goto next="#move_to_last_list_item"/>
      <elseif cond="userInput == 'previous'"/>
        <goto next="#move_to_previous_list_item"/>
      <elseif cond="userInput == 'repeat'"/>
        <goto next="#handle_repeat_it"/>
      <elseif cond="userInput == 'summary'"/>
        <goto next="#play_summary"/>
      <elseif cond="userInput == 'cancel'"/>
        <goto next="#canceled"/>
      <elseif cond="userInput == 'stop'"/>
        <goto next="#stopped"/>
      <elseif cond="userInput == 'mailMenu'"/>
        <goto next="#acknowledge_requested_email_menu"/>
      <elseif cond="userInput == 'mainMenu'"/>
        <goto next="#main_menu"/>
      <else/>
        <if cond="userInput == 'listRead'">
          <assign name="msgType" expr="'read'"/>
        <elseif cond="userInput == 'listUnread'"/>
          <assign name="msgType" expr="'unread'"/>
        <elseif cond="userInput == 'listUnreadAddrToMe'"/>
          <assign name="msgType" expr="'unreadAddrToMe'"/>
        </if>

        <goto next="#load_requested_message_list"/>
      </if>
    </block>
  </form>

  <%-- 2.13(c) Handles Repeat It --%>
  <form id="handle_repeat_it">
    <block>
      <if cond="msgBodyHasBeenHeard == 'true'">
        <goto next="#read_message_body"/>
      <else/>
        <goto next="#play_message_header"/>
      </if>
    </block>
  </form>
  
  <%-- 2.14 Read Message Body --%>
  <form id="read_message_body">
    <subdialog name="read_body" src="<util:url file="dialogs/readMessageBody.jsp" comp="mail"/>" namelist="msgIndex">
      <param name="p_path" expr="prompt_path"/>

      <filled>
        <assign name="msgBodyHasBeenHeard" expr="'true'"/>

        <assign name="userInput" expr="read_body.userInput"/>
        <goto next="#handle_user_input"/>
      </filled>
    </subdialog>
  </form>

  <%-- 2.15 Move to Previous List Item --%>
  <form id="move_to_previous_list_item">
    <block>      
      <if cond="msgIndex &lt;= 0">
        <goto next="#no_previous_message"/>
      <else/>
        <assign name="msgIndex" expr="msgIndex-1"/>
        <if cond="msgIndex == 0">
          <goto next="#announce_first_message"/>
        <else/>
          <goto next="#play_message_header"/>
        </if>
      </if>
    </block>
  </form>

  <%-- 2.16 No Previous Message --%>
  <form id="no_previous_message">
    <block>
      <audio expr="prompt_path + 'youre_at_the_first_message_in_the_list_we_cant_bac.wav'"/>
      <goto next="#play_message_header"/>
    </block>
  </form>

  <%-- 2.17 Move to Next List Item --%>
  <form id="move_to_next_list_item">
    <block>
      <if cond="msgIndex &gt;= numMsgsOfGivenType-1">
        <goto next="#announce_end_of_list"/>
      <else/>
        <assign name="msgIndex" expr="msgIndex+1"/>
        <if cond="msgIndex == numMsgsOfGivenType-1">
          <goto next="#announce_last_message"/>
        <else/>
          <goto next="#play_message_header"/>
        </if>
      </if>
    </block>
  </form>

  <%-- 2.18 Move to Last List Item --%>
  <form id="move_to_last_list_item">
    <block>
      <assign name="msgIndex" expr="numMsgsOfGivenType-1"/>
      <goto next="#announce_last_message"/>
    </block>
  </form>

  <%-- 2.19 Announce Last Message --%>
  <form id="announce_last_message">
    <block>
      <audio expr="prompt_path + 'heres_the_last_one.wav'"/>
      <goto next="#play_message_header"/>
    </block>
  </form>

  <%-- 2.20 Announce End of List --%>
  <form id="announce_end_of_list">
    <block>
      <audio expr="prompt_path + 'thats_it.wav'"/>
      <goto next="#email_menu"/>
    </block>
  </form>

  <%-- 2.21 Confirm Deleting Message --%>
  <form id="confirm_deleting_message">
    <var name="speakNum" expr="msgIndex+1"/>

    <block>
      <audio expr="prompt_path + 'deleting.wav'"/>
    </block>

    <subdialog name="speak_msg_number" src="<util:url file="dialogs/speakMessageNumber.jsp" comp="mail"/>" namelist="speakNum">
      <param name="msg_type"    expr="msgType"/>
      <param name="prompt_path" expr="prompt_path"/>
    </subdialog>

    <block>
      <audio expr="prompt_path + 'are_you_sure.wav'"/>
    </block>

    <subdialog name="YesOrNo" src="<util:url file="dialogs/GetYesOrNo.jsp" comp="common"/>">
      <param name="prompt_path" expr="prompt_path" />

      <filled>
        <if cond="YesOrNo.yesOrNo == 'yes'">
          <goto next="#mark_message_for_deletion"/>
        <else/>
          <goto next="#message_not_deleted"/>
        </if>
      </filled>
    </subdialog>
  </form>

  <%-- 2.22 Mark Message for Deletion --%>
  <form id="mark_message_for_deletion">
    <subdialog name="delete_msg" src="<util:url file="dialogs/deleteMsg.jsp" comp="mail"/>" namelist="msgIndex">
      <filled>
        <if cond="delete_msg.deleted == 'true'">
          <goto next="#message_deleted"/>
        <else/>
          <goto next="#message_deletion_failed"/>
        </if>
      </filled>
    </subdialog>
  </form>

  <%-- 2.23 Message Deleted --%>
  <form id="message_deleted">
    <block>
      <audio expr="prompt_path + 'deleted.wav'"/>

      <if cond="msgIndex &lt; numMsgsOfGivenType-1">
        <goto next="#move_to_next_list_item"/>
      <else/>
        <goto next="#announce_end_of_list"/>
      </if>
    </block>
  </form>

  <%-- 2.24 Message Not Deleted --%>
  <form id="message_not_deleted">
    <block>
      <audio expr="prompt_path + 'all_right_it_was_not_deleted.wav'"/>
      <goto next="#listen_for_user_input"/>
    </block>
  </form>

  <%-- 2.24 (b) Message Deletion Failed --%>
  <form id="message_deletion_failed">
    <block>
      <audio expr="prompt_path + 'was_not_deleted.wav'"/>
      <goto next="#listen_for_user_input"/>
    </block>
  </form>

  <%-- 2.25 No Messages --%>
  <form id="no_messages">
    <block>
      <audio expr="prompt_path + 'you_dont_have_any_messages_right_now_lets_go_back.wav'"/>
      <goto next="#main_menu"/>
    </block>
  </form>

  <%-- 2.26 Canceled --%>
  <form id="canceled">
    <block>
      <assign name="mailVoiceletAlreadyLoaded" expr="'true'"/>
				
      <audio expr="prompt_path + 'ok_canceled.wav'"/>
      <goto next="#email_menu"/>
    </block>
  </form>

  <%-- 2.27 Stopped --%>
  <form id="stopped">
    <block>
      <assign name="mailVoiceletAlreadyLoaded" expr="'true'"/>
				
      <audio expr="prompt_path + 'ok_stopped.wav'"/>
      <goto next="#email_menu"/>
    </block>
  </form>

  <%-- 2.28 Main Menu --%>
  <form id="main_menu">
    <block>
      <return/>
    </block>
  </form>

  <%-- Catching global grammars --%>

  <%-- Leaving --%>
  <catch event="goMailMenu">
    <goto next="#acknowledge_requested_email_menu"/>
  </catch>

  <%-- Main Menu --%>
  <catch event="goMainMenu">
    <goto next="#main_menu"/>
  </catch>

  <%-- Cancel --%>
  <catch event="goCancel">
    <goto next="#canceled"/>
  </catch>

  <%-- Stop --%>
  <catch event="goStop">
    <goto next="#stopped"/>
  </catch>
</vxml>

